/*  Garbage v.1.1.22 - plays a dice game called "Garbage."

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
------------------------------------------------------------------------
    To view the rules of Garbage, please view the included "RULES" file.
------------------------------------------------------------------------
(If you modify this source code put your name, the date and time, your e-mail address, and a 
description of what you did here. Thanks! -John)

e.g-- Revision made by John Kloosterman (strangeelixir23@yahoo.com)on March 25, 2003 @ 7:55 PM
	-Fixed a bug that caused every score to be 50 in line 58
	-Added a chunk of code to display the final score when you choose to quit

-------------------------------------------------------------------------
BUGS:
	Right now I have found and am trying to eradicate four bugs:
 		1: when I choose a non-1 or 5, the keep nums go out of whack
		2: whan I choose a non-1 or 5, the first three dice equal that number, but are not scored.
		3: scoring when a turn is over generates strange numbers as scores.
		4: Under some circumstances, the program will not see that 3 5's were rolled.
-------------------------------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>

int num[9];

/* function to tabulate score */
int sco()
{       int i = 0;
	int sc = 0;
        /* calcuate 1000's */
        if (num[9] >= 3)
        {       i = num[9] - 3;
                sc += 1000 + (i * 100);
        }
        sc += num[1] * 100;
	i = 0;
        /* calcuate 500's */
        if (num[8] >= 3)
        {       i = num[8] - 3;
                sc += 500 + (i * 50);
        }
        sc += num[5] * 50;
	i = 0;
        /* calcuate rest of numbers */
        if (num[2] >= 3) sc += 200;
        if (num[3] >= 3) sc += 300;
        if (num[4] >= 3) sc += 400;
        if (num[6] >= 3) sc += 600;
	return sc;
}

main()
{       int score[2];
/* the score */
        int die[5];
	/* what the dice are */
        int prints[5];
 /* the number underneath the dice that says whether or not you can keep it */
        int kept[5];
	/* whether or not the person has kept this die */
	int dis[5];
	/* what number the dice appear to be */
        char cankeep[5];
/* wheter or not you can keep a die */
        char command;
	/* what command the user enters */
        int numtmp;
	/* a temp variable */
	int kptrn = 0;
 /* if a person has kept a die this turn */
        int i = 0;
		/* general purpose counter */
        int exit = 0;
  /* if exit = 1 the program exits */
        int actplr = 0;
/* the active player */
        int garbage = 1;
/* if the dice rolled is no points at all */
        int counter = 0;
/* could be taken out, would require modifying the code: does nothing */
        int hasroll = 0;
/* if the player has rolled this turn yet */
        int rantmp;	/* a temp variable */
    	int nuntmp; /* how many points the game is up to */
        int j;
/* counter when i is already in use */
        int k;
/* counter when i and j are in use */
	int l = 0;
/* yet another counter */
        int numkept;
/* number of kept dice */
        score[1] = 0;
/* set scores to 0 */
        score[2] = 0;
        while (i < 5)
		/* set all values in arrays to 0 */
        {       i++;
                kept[i] = 0;
                die[i] = 0;
        }
	i = 0;
	while (i < 9)
	{	i++;
		num[i] = 0;
	}
        i = 0;
	nuntmp = 3000;
		/* this is temporary */
        srand(time());
	/* generates pur random #'s */
        printf("Garbage v1.1.22 by John Kloosterman. Press l for a list of commands.\n");
        while (exit != 1) 				/* big loop */
	{       if (counter == 0)
		{
			if (command != '\n')
			{	if (actplr == 0) printf("Player 1:");
/* display prompt */
				else printf("Player 2:");

			}
			scanf("%c", &command);
/* find out what the user wants to do */
			switch (command)	

			{	case 'r' :
				numkept = 0;
		/* the user wants to roll */
				while (i < 5)
				{	i++;
					if (kept[i] == 1) numkept++; /* tabulate how many dice are kept */
				}
				i = 0;
				while (i < 9)
/* make sure that num = 0 */
				{	i++;
					num[i] = 0;
				}
				i = 0;
				if (numkept == 5) 		/* if player has kept all the dice */
				{	score[actplr + 1] += sco();
					while (i < 5)
					{	i++;
						kept[i] = 0;
	/* start fresh again, tabulate score */
					}
					i = 0;
				}
				if (hasroll != 0 && kptrn == 0)
				{	printf("You must keep at least one dice before you can roll again!\n");
					counter = 0;
	
					continue;
				}
				kptrn = 0;
				while (i < 5)
				{	i++;
					rantmp = 1+(int) (6.0*rand()/RAND_MAX+1.0); 		/* find random #'s */
					rantmp -= 1+(int) (0.1*rand()/RAND_MAX+1.0); 		/* code from man page for rand */
					while (rantmp <= 0)
					{	rantmp = 1+(int) (6.0*rand()/RAND_MAX+1.0); /* need this so we don't get rantmp = 0 */
						rantmp -= 1+(int) (0.1*rand()/RAND_MAX+1.00);
					}
					if (kept[i] == 0) die[i] = rantmp;
					rantmp = 0;
					if (kept[i] != 1) num[die[i]]++;
				}
				i = 0;
				garbage = 1;
				if (num[1] >= 1) garbage = 0;
/* see if what is rolled is garbage */
				if (num[2] >= 3) garbage = 0;
				if (num[3] >= 3) garbage = 0;
				if (num[4] >= 3) garbage = 0;
				if (num[5] >= 1) garbage = 0;
				if (num[6] >= 3) garbage = 0;
				if (num[8] >= 1) garbage = 0;
				if (num[9] >= 1) garbage = 0;
				while (i < 5)
				{	i++;
					switch (die[i])
					{	case 9 :
				/* if die=8 or 9 they must be displayed as a 1 or 5 */
							dis[i] = 1;
							break;
						case 8 :
							dis[i] = 5;
							break;
						default :
							dis[i] = die[i];
							break;
					}
				}
				i = 0;
				printf(" -   -   -   -   -\n");
/* display dice */
				printf("|%d| |%d| |%d| |%d| |%d|\n", dis[1], dis[2], dis[3], dis[4], dis[5]);
				printf(" -   -   -   -   -\n");
				if (num[1] >= 3)
				{	while (i < 5)
			/* if there are 3 1's then the player has scored 1000 */
					{	i++;
						if (kept[i] == 0) if (die[i] == 1) die[i] = 9;
					}
					i = 0;
				}
				if (num[5] >= 3) 
			/* if there are 3 5's then the player has scored 500 */
				{	while (i < 5)
					{	i++;
						if (kept[i] == 0) if (die[i] == 5) die[i] = 8;
					}
					i = 0;
				}
				numtmp = 0;				/* preserve scores for later */
				numtmp = sco();

/* problem before here */
				while (i < 9) 			/* erase num's for next proc */
				{	i++;
					num[i] = 0;
				}
				i = 0;
				while (i < 5)			/* NOW tabulate numbers */
				{	i++;
					num[die[i]]++;
				}
				counter = 0;
				if (garbage == 1)
				{	printf("GARBAGE!\n");
 /* if you have garbage... */
					if (actplr == 0) actplr = 1;
					else actplr = 0;
					hasroll = 0;
					counter = 0;
					while (i < 5)
					{	i++;
						kept[i] = 0;
						die[i] = 0;
						prints[i] = 0;
						cankeep[i] = 'X';
					}
					i = 0;
					while (i < 9)
					{	i++;
						num[i] = 0;
					}
					i = 0;
					continue;
				}
				else
					/* otherwise, display the numbers so that the player can keep some dice */
				{	while (i < 5)
					{	i++;
						cankeep[i] = 'X';
/* this section is probably very buggy */
					}
					i = 0;
					while (i < 5)
					{	i++;
						if (die[i] != 1 && die[i] != 9)
						{	
							if (die[i] != 5 && die[i] != 8) 
							{	
								if (num[die[i]] >= 3) cankeep[i] = 'Y';
							}
							else cankeep[i] = 'Y';
						}
						else cankeep[i] = 'Y';
					}
					i = 0;
					while (i < 5)
					{	i++;
						if (cankeep[i] != 'Y') prints[i] = 0;
						else
						{	if (die[i] != 8)
							{
								if (die[i] != 9)
								{	if (die[i] != 1)
									{	if (die[i] != 5)
										{	prints[i] = i;
											j = 0;
											while (j < 5)
											{	j++;
												if (die[j] = die[i]) cankeep[j] = 'X';
											}
											j = 0;
										}	
										else prints[i] = i;
									}
									else prints[i] = i;
								}
								else
								{	prints[i] = i;
									j = 0;
									while (l < 3 && j < 5)
									{	j++;
										if (die[j] = 9)
										{	l++;
											cankeep[j] = 'X';
										}
									}
								}
							}
							else
							{	prints[i] = i;
								j = 0;
								l = 0;
								while (l < 3 && j < 5)
								{	j++;
									if (die[j] = 8)
									{	l++;
										cankeep[j] = 'X';
									}
								}
							}
						}

						if (kept[i] == 1) prints[i] = 0;
					}
					printf("Possible Points: %d\n", numtmp);
						numtmp = 0;
					i = 0;
					printf(" %d   %d   %d   %d   %d\n", prints[1], prints[2], prints[3], prints[4], prints[5]);
				}
				garbage = 1;
				hasroll = 1;
				i = 0;
				counter = 0;
		/* set variables back to original state */
				j = 0;
			break;

			case 'q':
				printf("\n");
					/* if the player decided to quit */
				printf("Final Scores:\n");
				printf("-------------\n");
				printf("Player 1: %d\n", score[1]);
				printf("Player 2: %d\n", score[2]);
				exit = 1;
			break;

			case 'l':
				printf("List of Commands\n");
	/* if the player wanted help */
				printf("----------------\n");
				printf("r - roll dice\n");
				printf("k - keep a die\n");
				printf("s - show score\n");
				printf("e - end turn\n");
				printf("q - quit\n");
				printf("l - this list\n");
				printf("----------------\n");
				counter = 0;
			break;

			case 'e':
				if (kptrn != 0)						/* if the player wants to end his turn */
				{	score[actplr + 1] += sco();
					i = 0;
					if (score[actplr + 1] >= nuntmp)
/* check to see if this player won */
					{	exit = 1;
						printf("Player %d wins with %d points.\n", actplr + 1, score[actplr + 1]);
						if (actplr == 1) numtmp = 0;
						else numtmp = 1;
						printf("Player %d was %d points behind.\n", numtmp + 1, score[actplr + 1] - score[numtmp + 1]);
						printf("You were playing up to %d points.\n", nuntmp);
					}
					while (i < 5)
/* set everything blank again for next player */
					{	i++;
						kept[i] = 0;
						die[i] = 0;
						prints[i] = 0;
					}
					i = 0;
					if (actplr == 1) actplr = 0;
					else actplr = 1;
					hasroll = 0;
					counter = 0;
				}
				else printf("You must keep at least 1 die before you can end your turn!\n");
			break;

			case 'k':		
				j = 0;
				k = 0;
				printf("Which die do you want to keep?");
				scanf("%d", &i);
				if (prints[i] > 0 && prints[i] < 6)
				{	if (die[i] == 1 || die[i] == 9 || die[i] == 5 || die[i] == 8) kept[i] = 1;
					else
					{	while (j < 5)
						{	j++;
							if (k < 3)
							{	if (die[i] == die[j]) 
/* if a player decided to keep a die that was not a 1 or 5 */
									{	kept[j] = 1;
  /* then you have to keep 3 of them */
										k++;
			/* this code automates the process */
									}
							}
						}
					}
					kptrn = 1;
				}
				else 
				{	if (i > 5 || i < 1) printf("Please enter in a valid number!\n");
					else printf("You can't keep that die!\n");
				}
				i = 0;
				counter = 0;
			break;

			case 's':
				printf(" Player 1	Player 2\n");
				/* print scores */
				printf("   %d		   %d\n",score[1],score[2]);
				counter = 0;
			break;

			default:
									/* if the player decided to do something we don't know */
				if (command != '\n') printf("\'%c\' is an unrecognized command. Press l for a list of commands.\n", command);
			break;
			
		}
	 } 
} 	
}
